// The main method in this class sets up the sentence corpus.

package reader;

import java.util.*;

public class Corpus {
   
    //**************************************************************************
     
    public void initialize(Scanner diskScanner, ArrayList<Sentence> text) {
        
        double charPos = 0; // cumulative character position
        int sentenceN = 0; // sentence #
        int wordN = 0; // word #
        
        // Initialize classes:
        Sentence s = new Sentence();
 
        while (diskScanner.hasNext()) {
            
            // Read in word attributes:
            Word w = new Word();
            w.iv.N = wordN;
            w.iv.freq = diskScanner.nextDouble();
            w.iv.length = diskScanner.nextInt();
            w.iv.cloze = diskScanner.nextDouble();;
            w.iv.letters = " " + diskScanner.next();
            
            // Calculate frequency variables:
            w.iv.lnFreq = Math.log(w.iv.freq);
            w.iv.freqClass = (int)Math.log10(w.iv.freq - 0.5);
            
            // Calculate letter positions & OVP:
            w.iv.charPos0 = charPos;
            w.iv.charPos1 = charPos + 1.0;
            w.iv.charPosN = w.iv.charPos1 + w.iv.length;
            w.iv.OVP = w.iv.charPos1 + (w.iv.length * 0.5);
            charPos += (w.iv.length + 1.0);
            
            // Add word to sentence:
            s.add(w);
            wordN++;

            // Identify end of sentence:
            if (w.iv.letters.charAt(w.iv.letters.length() - 1) == '@') {                 
                w.iv.letters = w.iv.letters.substring(0, w.iv.letters.length() - 1);                 
                s.N = sentenceN;
                s.numberWords = wordN;
                text.add(s);
                s = new Sentence();
                sentenceN++;
                wordN = 0;
                charPos = 0;
            } 
        }
    }
    
    //**************************************************************************
     
    // Re-initialize values of all word DVs:
    public void zeroDVs(ArrayList<Sentence> text) {
        for (int i = 0; i < Reader.NSentences; i++) {
            for (int j = 0; j < text.get(i).numberWords; j++) {
                text.get(i).get(j).dv.FFD = 0; 
                text.get(i).get(j).dv.GD = 0; 
                text.get(i).get(j).dv.N = 0; 
                text.get(i).get(j).dv.NFix = 0; 
                text.get(i).get(j).dv.NFPFix = 0;
                text.get(i).get(j).dv.Pr1 = 0; 
                text.get(i).get(j).dv.Pr2 = 0; 
                text.get(i).get(j).dv.PrF = 0;  
                text.get(i).get(j).dv.PrS = 0; 
                text.get(i).get(j).dv.SFD = 0; 
                text.get(i).get(j).dv.TT = 0; 
            }
        }
    }
    
}
