// The methods in this class implements the random and systematic error 
// components of saccade execution.

package reader;

import java.util.*;

public class Saccade {
    
    // Initialize classes:
    Random r = new Random();
    
    //**************************************************************************
     
    // Calculate random error component of saccade:
    double randomError(double intendedSaccade) {
        double result = r.nextGaussian() * (Reader.Eta1 + (Math.abs(intendedSaccade) * Reader.Eta2));
        return result;
    }
    
    //**************************************************************************
     
    // Calculate systematic error component of saccade:
    double systematicError(double intendedSaccade, double launchSiteFixDur) {
        double result = (Reader.Psi - Math.abs(intendedSaccade)) * ((Reader.Omega1 - Math.log(launchSiteFixDur)) / Reader.Omega2);
        if (intendedSaccade < 0) result *= -1.0;
        return result;
    }
}
