// This class contains utility methods.

package reader;

import java.util.*;

public class Utility {
    
    double meanFixDur = 0;
    double meanSaccadeLength = 0;
    double NFixations = 0;
    double NProFixations = 0;
    double NRegressions = 0;
    double NSkips = 0;
    double totalTime = 0;

    //**************************************************************************
    
    public void calcMeans(ArrayList<Fixation> trace, Utility utility) {
        
        if (trace.size() > 0) {
        utility.meanFixDur += trace.get(0).dur;
        utility.totalTime += trace.get(0).dur;
        utility.NFixations++;
        for (int i = 1; i < trace.size(); i++) {
            utility.meanFixDur += trace.get(i).dur;
            utility.totalTime += trace.get(i).dur;
            utility.NFixations++;
            
            // Saccade length includes only progressive saccades:
            if (trace.get(i - 1).word < trace.get(i).word) {
                utility.meanSaccadeLength += (trace.get(i).pos - trace.get(i - 1).pos);
                utility.NProFixations++;
            }
            else utility.NRegressions++;
            if ((trace.get(i).word - trace.get(i - 1).word) > 1) utility.NSkips++;
        }
        utility.totalTime += (trace.size() * Reader.S); 
        }
    }
}
