// This class contains independent and dependent variables for each word.

package reader;

public class Word {
    
    DV dv = new DV(); // Initialize new DVs
    IV iv = new IV(); // Initialize new IVs
    
    // Dependent variables:
    public class DV {
        double FFD = 0; // first-fixation duration
        double FixDist[] = new double[Reader.maxWordLength]; // fixation distribution
        int fixPos = 0; // fixation position
        int fixPosN[] = new int[Reader.maxWordLength]; // IOVP fixation counts
        double GD = 0; // gaze duration
        double IOVP[] = new double[Reader.maxWordLength]; // IOVP distributions
        int N = 0; // count (e.g., for frequency-class means)
        int NFix = 0; // # fixations
        int NFPFix = 0; // # first-pass fixations
        double Pr1 = 0; // prob. of single fixation
        double Pr2 = 0; // prob. of two or more fixations
        double PrF = 0; // prob. of fixating
        double PrS = 0; // prob. of skipping
        double RefixProb[] = new double[Reader.maxWordLength]; // refixation probabilities
        double SFD = 0; // single-fixation duration
        double TT = 0; // total time
    }
    
    // Independent variables:
    public class IV {
        double charPos0; // cumulative # of blank space preceding word
        double charPos1; // cumulative # of first letter
        double charPosN; // cumulative # of last letter
        double cloze; // cloze predictability
        int freqClass; // frequency class (1 = 1-10, 2 = 11-100, etc.)
        double freq; // frequency count (per million)
        double length; // word length (# of letters)
        String letters; // actual letters of words
        double lnFreq; // natural logarithm of word frequency
        int N; // within-sentence word #
        double OVP; // optimal viewing position
        char syntax; // syntactic category
    }
}
